const express = require("express");
const router = express.Router();
const multer = require("multer");
const authorize = require("../../../../middlewares/authorize-sapps");
const prescriptionService = require("./prescription.service");

router.post("/create", authorize(), create);
router.post("/", authorize(), getAll);
router.post("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.delete("/:id", authorize(), _delete);

module.exports = router;

/**
 * Create a new dosageUnit
 * @param {Object} req.body - The dosageUnit data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created dosageUnit
 */
function create(req, res, next) {
	prescriptionService
		.create(req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Get a list of all dosageUnits
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of dosageUnits
 */
function getAll(req, res, next) {
	prescriptionService
		.getAll(req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Get an array of dosageUnit objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of dosageUnit objects
 */
function option(req, res, next) {
	prescriptionService
		.option(req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Count the number of dosageUnits matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of dosageUnits
 */
function count(req, res, next) {
	prescriptionService
		.count(req.query)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Update an existing dosageUnit
 * @param {number} req.params.id - The dosageUnit ID to be updated
 * @param {Object} req.body - The dosageUnit data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated dosageUnit
 */
function update(req, res, next) {
	prescriptionService
		.update(req.params.id, req.body)
		.then((result) => res.json(result))
		.catch(next);
}

/**
 * Delete a dosageUnit
 * @param {number} req.params.id - The dosageUnit ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
	prescriptionService
		.delete(req.params.id)
		.then((result) => res.json(result))
		.catch(next);
}
